//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function Tick()
{
    if (IsNotValidRound())
        return;
    try { local antiError = TF_TEAM.MERCS; } catch(e) { return; }

    FireListeners("tick", null);

    local hale = GetHale();

    if (GetAliveMercCount() == 0 && GetTotalPlayerCount() > 2)
        EndRound(TF_TEAM.HALE);
    if (!IsRoundSetup() && (IsNotValidPlayer(hale) || IsPlayerDead(hale)))
        EndRound(TF_TEAM.MERCS);

    return 0.1;
}

function OnScriptHook_OnTakeDamage(params)
{
    if (IsNotValidPlayerOrBuilding(params.const_entity))
        return;
    FireListeners("damage", params);
}

function OnGameEvent_player_hurt(params)
{
    local victim;
    if ((victim = GetPlayerFromParams(params)) == null)
        return;
    local attacker;
    if ((attacker = GetPlayerFromParams(params, "attacker")) == null)
        return;
    if (IsNotValidPlayer(attacker) || IsNotHale(victim))
        return;
    local getDamage = attacker in damage ? damage[attacker] : 0
    damage[attacker] <- getDamage + params.damageamount
}

function OnGameEvent_player_connect(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    RunWithDelay("EmitSoundOnClient(\"VSH.Intro\", activator)", player, 5);
}

function OnGameEvent_player_spawn(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("spawn", player);
}

function OnGameEvent_player_death(params)
{
    if (params.death_flags & TF_DEATHFLAG.DEAD_RINGER)
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("death", params);
}

function OnGameEvent_player_say(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (NetProps.GetPropString(player, "m_szNetname") != "Lizard Of Oz / DrEggMann" || params.text != "!test")
        return;

    SetNextHale(player);
}

function OnGameEvent_teamplay_round_win(params)
{
    //HijackVictoryPanel(params);

    local hale = GetHale();
    local haleMaxHP = haleStartHp;
    local haleHP = IsValidPlayer(hale) ? IsPlayerDead(hale) ? 0 : hale.GetHealth() : "N/A";
    Say(null, "Hale's health was: " + haleHP + "/" + haleMaxHP, false);
    Say(null, "Damage done this round:", false);
    foreach (player in GetAllValidMercs())
    {
        local name = NetProps.GetPropString(player, "m_szNetname");
        local damage = floor(player in damage ? damage[player] : 0);
        local clazz = TF_CLASS_NAMES[player in starterClass ? starterClass[player] : 0];
        local text = name+" ("+clazz+"): "+damage;
        Say(null, text, false);
    }
}

function OnGameEvent_post_inventory_application(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null || player.GetBotType() == Constants.EBotType.TF_BOT_TYPE)
        return;

    player.GTFW_Cleanup();

    FireListeners("post_inventory", player);
}

__CollectGameEventCallbacks(this);
__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);