//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function SetConvars()
{
    Convars.SetValue("tf_weapon_criticals", 1);
    Convars.SetValue("mp_teams_unbalance_limit", 0);
    Convars.SetValue("mp_respawnwavetime", 999999);
    Convars.SetValue("tf_classlimit", 0);
    Convars.SetValue("mp_forcecamera", 0);
    Convars.SetValue("sv_alltalk", 1);
    Convars.SetValue("tf_dropped_weapon_lifetime", 0);
    //Convars.SetValue("mp_idlemaxtime", 5);
    //Convars.SetValue("mp_idledealmethod", 1);

    /*Convars.SetValue("tf_arena_use_queue", 0);
    Convars.SetValue("tf_arena_max_streak", 9999);
    Convars.SetValue("tf_arena_first_blood", 0);
    Convars.SetValue("tf_arena_override_team_size", 32);
    Convars.SetValue("tf_arena_preround_time", setupTime);
    Convars.SetValue("tf_player_movement_restart_freeze", 0);*/
}
SetConvars();

function SpawnHelperEntities()
{
    local teamFilterHale = SpawnEntityFromTable("filter_activator_tfteam", {
        Negated = 0,
        TeamNum = 3,
        targetname = "filter_team_hale",
    })

    local teamFilterMercs = SpawnEntityFromTable("filter_activator_tfteam", {
        Negated = 0,
        TeamNum = 2,
        targetname = "filter_team_mercs",
    })

    local trigger = SpawnEntityFromTable("trigger_multiple", {
        origin = "0 0 0",
        spawnflags = 1,
        IsEnabled = false,
        StartDisabled = 1,
        filtername = "filter_team_mercs",
        targetname = "hale_charge_zone",
    });

    trigger.KeyValueFromInt("solid", 2)
    trigger.KeyValueFromString("mins", "-55 -55 -20")
    trigger.KeyValueFromString("maxs", "55 55 120")
    EntityOutputs.AddOutput(trigger, "OnStartTouch", "logic_script_vsh", "RunScriptCode","haleChargeAbility.BashTarget(activator)", 0, -1)

    trigger = SpawnEntityFromTable("trigger_catapult", {
        origin = "0 0 0",
        spawnflags = 1,
        StartDisabled = 1,
        IsEnabled = false,
        physicsSpeed = 300,
        playerSpeed = 300,
        launchDirection = "-90 270 0",
        filtername = "filter_team_hale",
        targetname = "hale_charge_catapult"
    })

    trigger.KeyValueFromInt("solid", 2)
    trigger.KeyValueFromString("mins", "-64 -64 -96")
    trigger.KeyValueFromString("maxs", "64 64 96")

    if (!injectRoundLogic)
        return;

    local controlPoint = Entities.FindByClassname(null, "team_control_point");
    controlPoint.KeyValueFromInt("point_index", 0);
    controlPoint.KeyValueFromInt("point_start_locked", 1);
    EntFireByHandle(controlPoint, "SetLocked", "1", 0, null, null);
    EntityOutputs.AddOutput(controlPoint,
        "OnUnlocked",
        "gamerules"
        "PlayVO"
        "VSH.Point_Enabled",
        1, -1);
    EntityOutputs.AddOutput(controlPoint,
        "OnUnlocked",
        "!self"
        "ShowModel"
        "",
        0, -1);

    local pointMaster = Entities.FindByClassname(null, "team_control_point_master");
    if (pointMaster == null)
        SpawnEntityFromTable("team_control_point_master", {
            caplayout = 0,
            cpm_restrict_team_cap_win = 0,
            custom_position_x = -1,
            custom_position_x = -1,
            partial_cap_points_rate = 0
        });

    local pdLogic = Entities.FindByClassname(null, "tf_logic_player_destruction");
    if (pdLogic == null)
    {
        SpawnEntityFromTable("tf_logic_player_destruction", {
            blue_respawn_time = 9999,
            finale_length = 999999,
            flag_reset_delay = 60,
            heal_distance = 0,
            min_points = 1,
            points_per_player = 0,
            red_respawn_time = 0,
            targetname = "pd_logic",
            res_file = "Resource/UI/HudObjectivePDVSH.res"
        });
        local auto = SpawnEntityFromTable("logic_auto", {
            spawnflags = 1
        });
        EntityOutputs.AddOutput(auto,
            "OnMultiNewRound",
            "pd_logic"
            "SetPointsOnPlayerDeath",
            "0",
            0, -1);
        EntityOutputs.AddOutput(auto,
            "OnMultiNewRound",
            "pd_logic"
            "EnableMaxScoreUpdating",
            "",
            0, -1);
        EntityOutputs.AddOutput(auto,
            "OnMultiNewRound",
            "pd_logic"
            "DisableMaxScoreUpdating",
            "",
            5, -1);
    }

    local noSetup = false;
    local roundTimer = Entities.FindByClassname(null, "team_round_timer");
    if (roundTimer == null)
        roundTimer = SpawnEntityFromTable("team_round_timer", {
            auto_countdown = 1,
            max_length = 0,
            reset_time = 1,
            setup_length = setupLength,
            show_in_hud = 1,
            show_time_remaining = 1,
            start_paused = 0,
            timer_length = 240,
            StartDisabled = 0
        });
    else if (NetProps.GetPropInt(roundTimer, "m_nSetupTimeLength") == 0)
        NetProps.SetPropInt(roundTimer, "m_nSetupTimeLength", 5);

    EntityOutputs.AddOutput(roundTimer,
        "OnSetupFinished",
        "!self"
        "RunScriptFile",
        "vssaxtonhale/external_calls/finish_round_setup.nut",
        0, -1);
    EntityOutputs.AddOutput(roundTimer,
        "OnSetupFinished",
        "setup_relay"
        "Trigger",
        "",
        0, -1);
    EntityOutputs.AddOutput(roundTimer,
        "OnFinished",
        "!self"
        "RunScriptFile",
        "vssaxtonhale/external_calls/unlock_control_point.nut",
        0, -1);

    local feedbackRelay = SpawnEntityFromTable("logic_relay", {
        targetname = "TF2M_FeedbackRoundRelay",
        spawnflags = 0
    });
    EntityOutputs.AddOutput(feedbackRelay,
        "OnTrigger",
        "!self"
        "RunScriptFile",
        "vssaxtonhale/external_calls/set_feedback_round.nut",
        0, -1);

    feedbackRelay.ValidateScriptScope();
    feedbackRelay.GetScriptScope().Tick <- function()
    {
        vsh_vscript.FireListeners("frame_tick", null);
        return 0;
    }
    AddThinkToEnt(feedbackRelay, "Tick")
}
SpawnHelperEntities();

function UnlockControlPoint()
{
    local controlPoint = Entities.FindByClassname(null, "team_control_point");
    if (controlPoint != null)
        EntFireByHandle(controlPoint, "SetUnlockTime", "0", 0, null, null);
}