//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function TickMercs(void)
{
    if (IsNotValidRound())
        return;

    if (IsRoundSetup())
    {
        foreach (player in GetAllValidMercs())
            TickMercDuringSetup(player);
    }
    else
    {
        local mercsAlive = GetAliveMercCount(); //todo cache the value when the tick begins
        foreach (player in GetAliveMercs())
            TickMerc(player, mercsAlive);
    }
}
AddListener("tick", TickMercs, 0);

function TickMercDuringSetup(player)
{
    if (!IsPlayerAlive(player))
        player.ForceRegenerateAndRespawn();
    else
    {
        local desiredClass = NetProps.GetPropInt(player, "m_Shared.m_iDesiredPlayerClass");
        if (desiredClass != player.GetPlayerClass())
        {
            player.SetPlayerClass(desiredClass)
            player.ForceRegenerateAndRespawn();
        }
    }
}

function TickMerc(player, mercsAlive)
{
    local playerClass = player.GetPlayerClass();
    local weapon = player.GetActiveWeapon();

    if (mercsAlive <= 3)
        player.AddCond(Constants.ETFCond.TF_COND_OFFENSEBUFF);
    if (mercsAlive == 1)    //No, it's not "else if", because engie + sentry combo benefits from both crits and minicrits
        player.AddCond(Constants.ETFCond.TF_COND_CRITBOOSTED_ON_KILL);

    if (weapon != null
            && playerClass != TF_CLASS.SPY
            && GTFW_ReturnWeaponBySlotBool(weapon, TF_WEAPONSLOTS.MELEE)
            && weapon.GetWeaponId() != 656) //Holiday Punch gets no free crits
        player.AddCondEx(Constants.ETFCond.TF_COND_CRITBOOSTED_ON_KILL, 0.2, null);
}

function FrameTickMercs(void)
{
    foreach (player in GetAliveMercs())
        FrameTickMerc(player);
}
AddListener("frame_tick", FrameTickMercs, 0);

function FrameTickMerc(player)
{
    if (player.IsUsingActionSlot() || (NetProps.GetPropInt(player, "m_nButtons") & Constants.FButtons.IN_ATTACK3))
    {
        local ability = GetCurrentAbility(player);
        if (ability != null)
            ability.TryDoAction();
    }
}